"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));

// node_modules/lodash-es/_freeGlobal.js
var freeGlobal, freeGlobal_default;
var init_freeGlobal = __esm({
  "node_modules/lodash-es/_freeGlobal.js"() {
    freeGlobal = typeof global == "object" && global && global.Object === Object && global;
    freeGlobal_default = freeGlobal;
  }
});

// node_modules/lodash-es/_root.js
var freeSelf, root, root_default;
var init_root = __esm({
  "node_modules/lodash-es/_root.js"() {
    init_freeGlobal();
    freeSelf = typeof self == "object" && self && self.Object === Object && self;
    root = freeGlobal_default || freeSelf || Function("return this")();
    root_default = root;
  }
});

// node_modules/lodash-es/_Symbol.js
var Symbol, Symbol_default;
var init_Symbol = __esm({
  "node_modules/lodash-es/_Symbol.js"() {
    init_root();
    Symbol = root_default.Symbol;
    Symbol_default = Symbol;
  }
});

// node_modules/lodash-es/_getRawTag.js
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
  try {
    value[symToStringTag] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}
var objectProto, hasOwnProperty, nativeObjectToString, symToStringTag, getRawTag_default;
var init_getRawTag = __esm({
  "node_modules/lodash-es/_getRawTag.js"() {
    init_Symbol();
    objectProto = Object.prototype;
    hasOwnProperty = objectProto.hasOwnProperty;
    nativeObjectToString = objectProto.toString;
    symToStringTag = Symbol_default ? Symbol_default.toStringTag : void 0;
    getRawTag_default = getRawTag;
  }
});

// node_modules/lodash-es/_objectToString.js
function objectToString(value) {
  return nativeObjectToString2.call(value);
}
var objectProto2, nativeObjectToString2, objectToString_default;
var init_objectToString = __esm({
  "node_modules/lodash-es/_objectToString.js"() {
    objectProto2 = Object.prototype;
    nativeObjectToString2 = objectProto2.toString;
    objectToString_default = objectToString;
  }
});

// node_modules/lodash-es/_baseGetTag.js
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag2 && symToStringTag2 in Object(value) ? getRawTag_default(value) : objectToString_default(value);
}
var nullTag, undefinedTag, symToStringTag2, baseGetTag_default;
var init_baseGetTag = __esm({
  "node_modules/lodash-es/_baseGetTag.js"() {
    init_Symbol();
    init_getRawTag();
    init_objectToString();
    nullTag = "[object Null]";
    undefinedTag = "[object Undefined]";
    symToStringTag2 = Symbol_default ? Symbol_default.toStringTag : void 0;
    baseGetTag_default = baseGetTag;
  }
});

// node_modules/lodash-es/isObjectLike.js
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_default;
var init_isObjectLike = __esm({
  "node_modules/lodash-es/isObjectLike.js"() {
    isObjectLike_default = isObjectLike;
  }
});

// node_modules/lodash-es/isSymbol.js
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike_default(value) && baseGetTag_default(value) == symbolTag;
}
var symbolTag, isSymbol_default;
var init_isSymbol = __esm({
  "node_modules/lodash-es/isSymbol.js"() {
    init_baseGetTag();
    init_isObjectLike();
    symbolTag = "[object Symbol]";
    isSymbol_default = isSymbol;
  }
});

// node_modules/lodash-es/_trimmedEndIndex.js
function trimmedEndIndex(string) {
  var index = string.length;
  while (index-- && reWhitespace.test(string.charAt(index))) {
  }
  return index;
}
var reWhitespace, trimmedEndIndex_default;
var init_trimmedEndIndex = __esm({
  "node_modules/lodash-es/_trimmedEndIndex.js"() {
    reWhitespace = /\s/;
    trimmedEndIndex_default = trimmedEndIndex;
  }
});

// node_modules/lodash-es/_baseTrim.js
function baseTrim(string) {
  return string ? string.slice(0, trimmedEndIndex_default(string) + 1).replace(reTrimStart, "") : string;
}
var reTrimStart, baseTrim_default;
var init_baseTrim = __esm({
  "node_modules/lodash-es/_baseTrim.js"() {
    init_trimmedEndIndex();
    reTrimStart = /^\s+/;
    baseTrim_default = baseTrim;
  }
});

// node_modules/lodash-es/isObject.js
function isObject(value) {
  var type = typeof value;
  return value != null && (type == "object" || type == "function");
}
var isObject_default;
var init_isObject = __esm({
  "node_modules/lodash-es/isObject.js"() {
    isObject_default = isObject;
  }
});

// node_modules/lodash-es/toNumber.js
function toNumber(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol_default(value)) {
    return NAN;
  }
  if (isObject_default(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject_default(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim_default(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var NAN, reIsBadHex, reIsBinary, reIsOctal, freeParseInt, toNumber_default;
var init_toNumber = __esm({
  "node_modules/lodash-es/toNumber.js"() {
    init_baseTrim();
    init_isObject();
    init_isSymbol();
    NAN = 0 / 0;
    reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
    reIsBinary = /^0b[01]+$/i;
    reIsOctal = /^0o[0-7]+$/i;
    freeParseInt = parseInt;
    toNumber_default = toNumber;
  }
});

// node_modules/lodash-es/toFinite.js
function toFinite(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber_default(value);
  if (value === INFINITY || value === -INFINITY) {
    var sign = value < 0 ? -1 : 1;
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}
var INFINITY, MAX_INTEGER, toFinite_default;
var init_toFinite = __esm({
  "node_modules/lodash-es/toFinite.js"() {
    init_toNumber();
    INFINITY = 1 / 0;
    MAX_INTEGER = 17976931348623157e292;
    toFinite_default = toFinite;
  }
});

// node_modules/lodash-es/toInteger.js
function toInteger(value) {
  var result = toFinite_default(value), remainder = result % 1;
  return result === result ? remainder ? result - remainder : result : 0;
}
var toInteger_default;
var init_toInteger = __esm({
  "node_modules/lodash-es/toInteger.js"() {
    init_toFinite();
    toInteger_default = toInteger;
  }
});

// node_modules/lodash-es/before.js
function before(n, func) {
  var result;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  n = toInteger_default(n);
  return function() {
    if (--n > 0) {
      result = func.apply(this, arguments);
    }
    if (n <= 1) {
      func = void 0;
    }
    return result;
  };
}
var FUNC_ERROR_TEXT, before_default;
var init_before = __esm({
  "node_modules/lodash-es/before.js"() {
    init_toInteger();
    FUNC_ERROR_TEXT = "Expected a function";
    before_default = before;
  }
});

// node_modules/lodash-es/once.js
function once(func) {
  return before_default(2, func);
}
var once_default;
var init_once = __esm({
  "node_modules/lodash-es/once.js"() {
    init_before();
    once_default = once;
  }
});

// node_modules/lodash-es/lodash.js
var init_lodash = __esm({
  "node_modules/lodash-es/lodash.js"() {
    init_once();
  }
});

// src/helpers.ts
var import_helper_module_imports, HELPERS, helpers_default;
var init_helpers = __esm({
  "src/helpers.ts"() {
    "use strict";
    import_helper_module_imports = require("@babel/helper-module-imports");
    HELPERS = "\0compluginPluginBabelHelpers.js";
    helpers_default = function importHelperPlugin({ types: t }) {
      return {
        pre(file) {
          const cachedHelpers = /* @__PURE__ */ Object.create(null);
          file.set("helperGenerator", (name) => {
            if (!file.availableHelper(name)) {
              return null;
            }
            if (cachedHelpers[name]) {
              return t.cloneNode(cachedHelpers[name]);
            }
            return cachedHelpers[name] = (0, import_helper_module_imports.addNamed)(file.path, name, HELPERS);
          });
        }
      };
    };
  }
});

// src/index.ts
var require_src = __commonJS({
  "src/index.ts"(exports2, module2) {
    "use strict";
    var import_core = require("@babel/core");
    var import_complugin = require("complugin");
    init_lodash();
    var import_estree_to_babel = __toESM(require("estree-to-babel"));
    var import_lru_cache = __toESM(require("lru-cache"));
    init_helpers();
    var babelAstCache = globalThis.__babelAstLRUCache;
    if (!(babelAstCache instanceof import_lru_cache.default)) {
      babelAstCache = globalThis.__babelAstLRUCache = new import_lru_cache.default({
        max: 256,
        maxSize: 8388607,
        updateAgeOnGet: true,
        updateAgeOnHas: true,
        sizeCalculation: ({ start, end }, key) => key.length + (end || 255) - (start || 0)
      });
    }
    var initTransformCache = once_default(() => new import_lru_cache.default({
      max: 256,
      maxSize: 8388607,
      updateAgeOnGet: true,
      updateAgeOnHas: true,
      sizeCalculation: ([code, map], key) => code.length + ((map == null ? void 0 : map.length) ?? 0) + key.length
    }));
    var compluginBabel2 = (0, import_complugin.createComplugin)({
      name: "babel",
      enforce: void 0,
      factory(options, meta) {
        let CWD = process.cwd();
        if (meta.framework === "esbuild") {
          CWD = meta.build.initialOptions.absWorkingDir ?? CWD;
        }
        const {
          include: _include = [/\.(tsx?|jsx?|mjs)$/i],
          exclude: _exclude,
          cwd,
          cache = true,
          ..._babelOptions
        } = options ?? {};
        const babelOptions = {
          ..._babelOptions,
          cloneInputAst: false,
          ast: true,
          code: true,
          sourceMaps: true,
          compact: false,
          cwd: cwd ?? CWD
        };
        const transformCache = cache ? initTransformCache() : void 0;
        const getTransformOptionsAndWatchFiles = once_default(async () => {
          var _a, _b;
          const config = await (0, import_core.loadPartialConfigAsync)(babelOptions);
          const options2 = (config == null ? void 0 : config.options) ?? {};
          const watchFiles = /* @__PURE__ */ new Set();
          (options2.plugins ?? (options2.plugins = [])).push(helpers_default);
          if (config) {
            if (config.files) {
              ;
              (_b = (_a = config.files).forEach) == null ? void 0 : _b.call(_a, (configFile) => watchFiles.add(configFile));
            } else {
              if (typeof config.babelrc === "string") {
                watchFiles.add(config.babelrc);
              }
              if (config.config) {
                watchFiles.add(config.config);
              }
            }
          }
          return [options2, JSON.stringify(options2), watchFiles];
        });
        if (meta.framework === "esbuild") {
          meta.onResolveRegExp = new RegExp(`^${import_complugin.utils.escapeRegExp(HELPERS)}$`);
        }
        return {
          resolveId: (source) => source === HELPERS ? source : void 0,
          load: (id) => {
            if (id === HELPERS) {
              return (0, import_core.buildExternalHelpers)(null, "module");
            }
          },
          transformInclude: import_complugin.utils.createFilter(_include, _exclude),
          async transform(originalCode, id, ast) {
            const [transformOptions, transformOptionsStr, watchFiles] = await getTransformOptionsAndWatchFiles();
            const finallyOptions = {
              ...transformOptions,
              filename: id
            };
            if (transformCache) {
              const result2 = transformCache.get(transformOptionsStr + originalCode);
              if (result2) {
                const [code, map] = result2;
                return {
                  code,
                  map: map && this.sourceMap ? JSON.parse(map) : void 0
                };
              }
            } else {
              finallyOptions.sourceMaps = this.sourceMap;
              for (const watchFile of watchFiles) {
                this.addWatchFile(watchFile);
              }
            }
            let result;
            let babelAst = babelAstCache.get(originalCode);
            if (!babelAst) {
              try {
                babelAstCache.set(originalCode, babelAst = (0, import_estree_to_babel.default)(ast));
              } catch {
              }
            }
            if (!babelAst) {
              const parsedBabelAst = await (0, import_core.parseAsync)(originalCode, finallyOptions);
              if (parsedBabelAst) {
                babelAstCache.set(originalCode, babelAst = parsedBabelAst);
              }
            }
            if (babelAst) {
              result = await (0, import_core.transformFromAstAsync)(babelAst, originalCode, finallyOptions);
            } else {
              result = await (0, import_core.transformAsync)(originalCode, finallyOptions);
            }
            if (result) {
              const { code, ast: ast2, map } = result;
              if (code != null) {
                if (ast2) {
                  babelAstCache.set(code, ast2);
                }
                if (transformCache) {
                  transformCache.set(transformOptionsStr + originalCode, [code, map ? JSON.stringify(map) : void 0]);
                }
                return { code, map: this.sourceMap ? map : void 0 };
              }
            }
          }
        };
      }
    });
    compluginBabel2.default = compluginBabel2;
    module2.exports = compluginBabel2;
  }
});

// src/nuxt.ts
var import_index = __toESM(require_src());
module.exports = function(options) {
  this.extendBuild((config) => {
    const plugins = config.plugins ?? (config.plugins = []);
    plugins.unshift(import_index.default.webpack(options));
  });
  this.nuxt.hook("vite:extend", async (vite) => {
    const plugins = vite.config.plugins ?? (vite.config.plugins = []);
    plugins.push(import_index.default.vite(options));
  });
};
/**
 * @license
 * Lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="es" -o ./`
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
